include ProcessView.inc

.code
start:                                                   ; entry point
  invoke  GetModuleHandle,NULL                           ; get a module handle
  mov     hInstance,eax                                  ; and store it

  ; -- NT-based OS check ;)
  assume  fs:nothing                                     ; it's masm, so we need it...
  mov     eax,fs:[18h]                                   ; get TEB self pointer
  mov     ebx,fs:[30h]                                   ; get pointer to PEB /process data base
  .if     eax==7FFDE000h && ebx==7FFDF000h
    ; -- it's NT-based, so we are able to use debug mode!
    invoke  GetCurrentProcess                            ; get THIS process handle
    mov     _hProcess,eax                                ; and store it
    invoke  OpenProcessToken,_hProcess,TOKEN_ADJUST_PRIVILEGES or TOKEN_QUERY,addr _hToken
    lea     eax,tkp.Privileges[0].Luid 
    invoke  LookupPrivilegeValue,NULL,offset szString,eax 
    mov     tkp.PrivilegeCount,1 
    mov     tkp.Privileges[0].Attributes,SE_PRIVILEGE_ENABLED  
    invoke  AdjustTokenPrivileges,_hToken,FALSE,addr tkp, sizeof tkp, NULL, NULL
    invoke  CloseHandle,_hToken
  .endif

  invoke  InitCommonControls                             ; init treeview usage
  invoke  DialogBoxParam,hInstance,IDD_DIALOG,NULL,offset DlgProc,NULL
  invoke  ExitProcess,NULL                               ; cleanup and kill process

DlgProc      proc hWin:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

  .if     uMsg==WM_INITDIALOG                            ; WM_INITDIALOG
    invoke  ShowWindow,hWin,SW_MINIMIZE                  ; pop up effect
    invoke  LoadIcon,hInstance,IDI_ICON                  ; set application icon
    mov     hIcon,eax                                    ; and store it's handle
    invoke  SendMessage,hWin,WM_SETICON,1,hIcon          ; show the icon
    invoke  SendMessage,hWin,WM_SETTEXT,0,offset szAppName ; show application name
    invoke  TV_INIT,hWin,IDC_TREEVIEW,0ff0000h, 0DEF5F3h ; init the treeview
    invoke  ShowWindow,hWin,SW_SHOWNORMAL                ; show the final dialog 

  .elseif uMsg==WM_CLOSE                                 ; WM_CLOSE
    invoke  ShowWindow,hWin,SW_MINIMIZE                  ; minimize the window to taskbar
    invoke  EndDialog,hWin,0                             ; end the dialog

  .elseif uMsg==WM_COMMAND                               ; WM_COMMAND
    .if     wParam==IDC_UPDATE                           ; update button
      invoke  TV_INIT,hWin,IDC_TREEVIEW,0ff0000h, 0DEF5F3h ; init the treeview
      invoke  TV_UPDATE,hWin,IDC_TREEVIEW                ; and get the entrys
    .endif
  .else
    mov     eax,FALSE
    ret
  .endif
  mov    eax,TRUE
  ret
DlgProc      endp			

TV_INIT      proc theWindow:DWORD, theTree:DWORD, theTextColor:DWORD, theBackColor:DWORD
  LOCAL   _tvGetCount:DWORD                              ; number of entry's inside TreeView

  pushad                                                 ; store all registers
  invoke  SendDlgItemMessage,theWindow,theTree,TVM_GETCOUNT,0,0	; get the count
  mov     _tvGetCount,eax                                ; and store it

@@:
  invoke  SendDlgItemMessage,theWindow,theTree,TVM_DELETEITEM,0,0 ; delete loop
  dec     _tvGetCount                                    ; count-=1
  mov     eax,_tvGetCount                                ; did we...
  cmp     eax,0                                          ; ... delete all items?
  jg      @B                                             ; if not, continue
  
  mov     eax,theTextColor                               ; textcolor to eax
  mov     ebx,theBackColor                               ; backcolor to ebx

  .if     eax==ebx                                       ; both colors equal?
    push    0FFFFFFFFh                                   ; if so, ...
    pop     theBackColor                                 ; ... prepare ...
    push    0h                                           ; ... the default ...
    pop     theTextColor                                 ; colors!
  .endif

  ;----- set the choosen colors
  invoke  SendDlgItemMessage,theWindow,theTree,TVM_SETTEXTCOLOR,0,theTextColor
  invoke  SendDlgItemMessage,theWindow,theTree,TVM_SETBKCOLOR,0,theBackColor
  popad                                                  ; retore all registers
  ret                                                    ; return to caller
TV_INIT      endp 

TV_UPDATE    proc theWindow:DWORD, theTree:DWORD
  LOCAL  _firstSub:DWORD                                 ; first submenu in treeview
  LOCAL  _secondSub:DWORD                                ; second submenu in treeview
  
  pushad                                                 ; store all retisters
  invoke  CreateToolhelp32Snapshot, TH32CS_SNAPALL, 0    ; create a snapshot
  mov     hSnapShot, eax                                 ; and store the snapshot handle
  mov     myProcess.dwSize, sizeof myProcess             ; set the size of Proc. structure
  invoke  Process32First,hSnapShot, ADDR myProcess       ; get the first process
  .while eax                                             ; do while processes exists
    invoke  wsprintf,addr myCatBuffer,addr szTemplateDWORD,myProcess.th32ProcessID
    invoke  lstrcat,addr myCatBuffer,addr myProcess.szExeFile
    lea     eax,myCatBuffer                              ; pointer to buffertext
    mov     mytvi.hParent,NULL                           ; start with hightest level
    mov     mytvi.item.hItem-4,TVIF_TEXT                 ; it's text
    mov     mytvi.item.pszText, eax                      ; the text to shoe (PID + Name)
    invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
    mov     mytvi.hParent,eax                            ; we get a new submenu level handle
    mov     _firstSub,eax                                ; store the first sub handle

    ; -- process information caption
    lea     eax,szProcessInfo
    mov     mytvi.item.pszText, eax
    invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
    mov     mytvi.hParent,eax                            ; next sub

    ; -- show process related informations
    invoke  INFO_SHOW,theWindow,theTree,addr szProcessID,myProcess.th32ProcessID
    invoke  INFO_SHOW,theWindow,theTree,addr szParentProcessID,myProcess.th32ParentProcessID
    invoke  INFO_SHOW,theWindow,theTree,addr szDefaultHeapID,myProcess.th32DefaultHeapID
    invoke  INFO_SHOW,theWindow,theTree,addr szModuleID,myProcess.th32ModuleID
    invoke  INFO_SHOW,theWindow,theTree,addr szNumOfThreads,myProcess.cntThreads
    invoke  INFO_SHOW,theWindow,theTree,addr szNumOfUsers,myProcess.cntUsage
    invoke  INFO_SHOW,theWindow,theTree,addr szBasePrioity,myProcess.pcPriClassBase
    invoke  INFO_SHOW,theWindow,theTree,addr szProcessFlags,myProcess.dwFlags
  
    ; -- get access to actual process to analyze
    invoke  CreateToolhelp32Snapshot, TH32CS_SNAPALL, myProcess.th32ProcessID
    mov     hSnapShot2,eax                               ; store the process related snapshot handle

    ; -- module information caption
    mov     myModule.dwSize, sizeof myModule             ; set the size of module structure
    invoke  Module32First,hSnapShot2, addr myModule      ; get first module of process
    push    eax                                          ; return result to stack
    cmp     eax,0                                        ; is it 0 (== failed)
    jne     @F                                           ; if not, continue
    pop     eax                                          ; restore return result 
    jmp     _toThread                                    ; continue with threads

@@: 
    push    _firstSub                                    ; where to start
    pop     mytvi.hParent                                ; it's the first subfolder
    lea     eax,szModuleInfo                             ; module caption
    mov     mytvi.item.pszText, eax
    invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
    mov     mytvi.hParent,eax                            ; next sub
    mov     _secondSub,eax                               ; store the subfolder
    pop     eax                                          ; reture result of module32first
    .while eax                                           ; as long as eax !=0 do loop
      push    _secondSub
      pop     mytvi.hParent
      lea     eax,myModule.szModule                      ; the moduleName
      mov     mytvi.item.pszText, eax
      invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
      mov     mytvi.hParent,eax                          ; next sub
      invoke  INFO_SHOW,theWindow,theTree,addr szModuleID,myModule.th32ModuleID
      invoke  INFO_SHOW,theWindow,theTree,addr szModuleHandle,myModule.hModule
      invoke  INFO_SHOW,theWindow,theTree,addr szGlobalUsage,myModule.GlblcntUsage
      invoke  INFO_SHOW,theWindow,theTree,addr szProcessUsage,myModule.ProccntUsage
      invoke  Module32Next,hSnapShot2, addr myModule     ; get next module
    .endw    

_toThread:
    ; -- thread information caption
    mov     myThread.dwSize, sizeof myThread             ; set the size of HL. structure
    invoke  Thread32First,hSnapShot2, addr myThread      ; get first thread of process
    push    eax                                          ; return result to stack
    cmp     eax,0                                        ; is it 0 (== failed)
    jne     @F                                           ; if not, continue
    pop     eax                                          ; restore return result 
    jmp     _toHeap                                      ; continue with heaps
@@:
    push    _firstSub
    pop     mytvi.hParent
    lea     eax,szThreadInfo                             ; thread heading
    mov     mytvi.item.pszText, eax
    invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
    mov     mytvi.hParent,eax                            ; next sub
    pop     eax                                          ; restore result from thread32first
    .while eax
      mov     eax,myThread.th32OwnerProcessID
      .if     eax == myProcess.th32ProcessID
        invoke  INFO_SHOW,theWindow,theTree,addr szThreadID,myThread.th32ThreadID
      .endif
      invoke  Thread32Next,hSnapShot2, addr myThread     ; get next thread
    .endw    

_toHeap:
    ; -- get the heap informations
    mov     myHeapList.dwSize, sizeof myHeapList
    invoke  Heap32ListFirst,hSnapShot2,addr myHeapList
    push    eax                                          ; return result to stack
    cmp     eax,0                                        ; is it 0 (== failed)
    jne     @F                                           ; if not, continue
    pop     eax                                          ; restore return result 
    jmp     _toEnd                                       ; comtinue with next process    
@@:
    push    _firstSub
    pop     mytvi.hParent
    lea     eax,szHeapInfo
    mov     mytvi.item.pszText, eax
    invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
    mov     mytvi.hParent,eax                            ; next sub
    mov     _secondSub,eax
    pop     eax
    .while  eax
      invoke  INFO_SHOW,theWindow,theTree,addr szHeapID,myHeapList.th32HeapID
      mov     myHeapList.dwSize, sizeof myHeapList
      invoke  Heap32ListNext,hSnapShot2,addr myHeapList  ; get next heap  
    .endw    

_toEnd:
    invoke  CloseHandle,hSnapShot2                       ; close snapshot process handle
    invoke  Process32Next,hSnapShot, ADDR myProcess      ; get the next process
  .endw  
  invoke  CloseHandle,hSnapShot                          ; close snapshot handle
  popad                                                  ; restore all registers
  ret                                                    ; return to caller
TV_UPDATE endp

INFO_SHOW proc theWindow:DWORD, theTree:DWORD, theTemplate:DWORD, theValue:DWORD
  pushad                                                 ; store all registers
  invoke  wsprintf,addr myBuffer,theTemplate,theValue    ; convert value
  lea     eax,myBuffer                                   ; and 
  mov     mytvi.item.pszText, eax                        ; display it in TREEVIEW
  invoke  SendDlgItemMessage,theWindow,theTree,TVM_INSERTITEM,0,addr mytvi
  popad                                                  ; restore all registers
  ret                                                    ; return to caller
INFO_SHOW endp

end start                                                ; end of application